/*
  ACDC - popular AUDIO Compact Disk player 4  LiNUX
  
     made by Tomaz Ocepek
     	     Mitja Slenc
     
  the source code is kinda wanky, not well documented, err anyway
  who needs those wanky comments anyway :)
*/
         

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <termios.h>
#include <mntent.h>
#include <getopt.h>
#include "struct.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ncurses/curses.h>
#define MAXMODES 2
#define MAX(a,b) ((a)>(b)?(a):(b))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define makebox(a,b,c,d,e,colz) damakebox(a,b,c,d,e,1,colz)
#define makebox2(a,b,c,d,e,colz) damakebox(a,b,c,d,e,0,colz)
#define DADIR "/usr/local/info/acdc/"

extern struct play *playlist;
extern struct cdinfo thiscd, *cd;
extern int cur_track, cur_index, cur_lasttrack, cur_firsttrack, cur_pos_abs,
       cur_frame, cur_pos_rel, cur_tracklen, cur_cdlen, cur_ntracks,
       cur_nsections, cur_cdmode, cur_listno, cur_stopmode, exit_on_eject,
       cur_balance;
extern char *cur_artist, *cur_cdname, *cur_trackname;
extern char cur_contd, cur_avoid;
extern int boxchars[MAXMODES][8];                       
extern int reverse,dumbi,muted,cur_volume;


void init()
{
  boxchars[0][0]=ACS_ULCORNER;
  boxchars[0][1]=ACS_LLCORNER;
  boxchars[0][2]=ACS_URCORNER;
  boxchars[0][3]=ACS_LRCORNER;
  boxchars[0][4]=ACS_HLINE;
  boxchars[0][5]=ACS_HLINE;
  boxchars[0][6]=ACS_VLINE;
  boxchars[0][7]=ACS_VLINE;
}

void damakebox(int x1, int y1, int x2, int y2, int grafmode, int corners, int colz)
{
  int x,y,minx,maxx,miny,maxy;

  minx=MIN(x1,x2); maxx=MAX(x1,x2);
  miny=MIN(y1,y2); maxy=MAX(y1,y2);
  
  attron(colz);
  
  if (corners) {
    mvaddch(miny,minx,boxchars[grafmode][0]);
    mvaddch(maxy,minx,boxchars[grafmode][1]);
    mvaddch(miny,maxx,boxchars[grafmode][2]);
    mvaddch(maxy,maxx,boxchars[grafmode][3]);
  }

  for (x=minx+1; x<maxx; x++)
    mvaddch(miny,x,boxchars[grafmode][4]);

  for (x=minx+1; x<maxx; x++)
    mvaddch(maxy,x,boxchars[grafmode][5]);

  for (y=miny+1; y<maxy; y++)
    mvaddch(y, minx, boxchars[grafmode][6]);

  for (y=miny+1; y<maxy; y++)
    mvaddch(y, maxx, boxchars[grafmode][7]);
  attroff(COLOR_PAIR(1));
}

void dastrbox(int x1, int y1, int x2, int y2, int grafmode, char *str, int corn, int colz)
{
  damakebox(x1,y1,x2,y2,grafmode,corn,colz);
  attron(COLOR_PAIR(1));
  mvaddstr(y1,(x1+x2-strlen(str))/2+1,str);
  attroff(COLOR_PAIR(1));
}

void strbox(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz)
{
  dastrbox(x1,y1,x2,y2,grafmode,str,1,colz);
}

void strbox2(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz)
{
  dastrbox(x1,y1,x2,y2,grafmode,str,0,colz);
}

void dapanel(int x1, int y1, int x2, int y2, int grafmode, char *str, int corn, int colz, int colz1, int atribut)
{
  damakebox(x1,y1,x2,y2,grafmode,corn,colz);
  attrset(atribut);
  attron(colz1);
  mvaddstr((y1+y2)/2,(x1+x2-strlen(str))/2+1,str);
  attroff(colz1);
  attrset(A_NORMAL);
}

void panel(int x1, int y1, int x2, int y2, int grafmode, char *str, int colz, int colz1, int atribut)
{
  dapanel(x1,y1,x2,y2,grafmode,str,1,colz,colz1,atribut);
}

void dastrpanel(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int corn, int colz, int colz1)
{
  char buff[1000];
  int x;

  if (strlen(str)>(x2-x1-1)) {
    strncpy(buff,str,(x2-x1-1));
    x=x1+1;
  }
  else {
    x=(x1+x2-strlen(str))/2+1;
    strcpy(buff,str);
  }
  dastrbox(x1,y1,x2,y2,grafmode,title,corn,colz);
  if (reverse) attron(A_REVERSE);
  attron(colz1);  
  mvaddnstr((y1+y2)/2,x,buff,(x2-x1-1));
  if (reverse) attroff(A_REVERSE);
  attroff(colz1);
}

void dastrpanelspc(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int specch, int corn, int colz, int colz1)
{
  char buff[1000];
  int x;

  if (strlen(str)>(x2-x1-1)) {
    strncpy(buff,str,(x2-x1-1));
    x=x1+1;
  }
  else {
    x=(x1+x2-strlen(str))/2+1;
    strcpy(buff,str);
  }
  dastrbox(x1,y1,x2,y2,grafmode,title,corn,colz);
  if (reverse) attron(A_REVERSE);
  attron(colz1);  
  mvaddnstr((y1+y2)/2,x,buff,(x2-x1-1));
  if (reverse) attroff(A_REVERSE);
  attroff(colz1);
  attrset(A_BOLD); attron(COLOR_PAIR(5));
  mvaddch(y2-1,x2-2,specch); attrset(A_NORMAL); attroff(COLOR_PAIR(5));
}

void strpanel(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int colz, int colz1)
{
  dastrpanel(x1,y1,x2,y2,grafmode,title,str,1,colz,colz1);
}

void strpanelspc(int x1, int y1, int x2, int y2, int grafmode, char *title, char *str, int specch, int colz, int colz1)
{
  dastrpanelspc(x1,y1,x2,y2,grafmode,title,str,specch,1,colz,colz1);
}

int countlines(char *str,int w)
{
  int n=0,a,l;

  l=0;

  if (!str) return 1;

  for (a=0; *(str+a); a++) {
    l++;
    if ((*(str+a)==9) || (l>w)) {
      n++;
      l=0;
    }
  }

  return n+1;
}

void getline(char *src, int line, int w, char *buff)
{
  int n=1,a,l;

  l=0;

  if ((line>countlines(src,w)) || (line<1) || (!src)) {
    *buff=0;
    return;
  }

  for (a=0; (*(src+a)) && (n!=line); a++,l++) {
    if ((*(src+a)==9) || (l>w)) {
      n++;
      l=0;
    } 
  }

  for (l=0;(*(src+a)) && (l<=w) && (*(src+a)!=9);a++)
  {
    *(buff+l)=*(src+a);
    l++;
  }

  *(buff+l)=0;
}

void dohilite(int a)
{
 int kkk;
 
  switch(a) {
    case  1: makebox2(4,   8, 8,  10,  0,COLOR_PAIR(2)); break;
    case  2: makebox2(8,   8, 12, 10,  0,COLOR_PAIR(2)); break;
    case  3: makebox2(12,  8, 16, 10,  0,COLOR_PAIR(2)); break;
    case  4: makebox2(4,   6, 8,   8,  0,COLOR_PAIR(2)); break;
    case  5: makebox2(8,   6, 12,  8,  0,COLOR_PAIR(2)); break;
    case  6: makebox2(12,  6, 16,  8,  0,COLOR_PAIR(2)); break;
    case  7: makebox2(4,   4, 8,   6,  0,COLOR_PAIR(2)); break;
    case  8: makebox2(8,   4, 12,  6,  0,COLOR_PAIR(2)); break;
    case  9: makebox2(12,  4, 16,  6,  0,COLOR_PAIR(2)); break;
    case 10: { 
               makebox2(4,10,12,12,0,COLOR_PAIR(2)); 
               attron(COLOR_PAIR(2)); mvaddch(10,8,ACS_BTEE);
               attroff(COLOR_PAIR(2));
             } break;
    case 11: strbox(50,4,61,6,0," F1 ",COLOR_PAIR(3)); break;
    case 12: strbox(65,4,76,6,0," F2 ",COLOR_PAIR(3)); break;
    case 13: {
               attron(COLOR_PAIR(1)); mvaddstr(7,51," F3 "); attroff(COLOR_PAIR(1));
               attron(COLOR_PAIR(3)); mvaddch(7,50,ACS_ULCORNER);
               mvaddch(8,50,ACS_VLINE); mvaddch(7,55,ACS_HLINE); mvaddch(7,56,ACS_HLINE);
               mvaddch(9,50,ACS_LLCORNER); mvaddch(9,51,ACS_HLINE);
               mvaddch(9,52,ACS_HLINE); attroff(COLOR_PAIR(3));
             } break;
    case 14: {
               attron(COLOR_PAIR(1)); mvaddstr(7,59," F4 "); attroff(COLOR_PAIR(1));
               attron(COLOR_PAIR(3)); 
               for (kkk=0;kkk<4;kkk++) mvaddch(7,55+kkk,ACS_HLINE);
               mvaddch(7,63,ACS_HLINE);
               for (kkk=0;kkk<8;kkk++) mvaddch(9,56+kkk,ACS_HLINE);
               attroff(COLOR_PAIR(3));
             } break;
    case 15: {
               attron(COLOR_PAIR(1)); mvaddstr(7,64," F5 "); attroff(COLOR_PAIR(1));
               attron(COLOR_PAIR(3)); 
               mvaddch(7,63,ACS_HLINE); 
               for (kkk=0;kkk<4;kkk++) mvaddch(7,68+kkk,ACS_HLINE);
               for (kkk=0;kkk<8;kkk++) mvaddch(9,63+kkk,ACS_HLINE);
               attroff(COLOR_PAIR(3));
             } break;
    case 16: {
               attron(COLOR_PAIR(1)); mvaddstr(7,72," F6 "); attroff(COLOR_PAIR(1));
               attron(COLOR_PAIR(3)); mvaddch(7,70,ACS_HLINE); mvaddch(7,71,ACS_HLINE);
               mvaddch(7,76,ACS_URCORNER); mvaddch(8,76,ACS_VLINE);
               mvaddch(9,76,ACS_LRCORNER); mvaddch(9,74,ACS_HLINE); 
               mvaddch(9,75,ACS_HLINE); attroff(COLOR_PAIR(3));
             } break; 
    case 17: 
    case 18: strbox(21,4,45,6,0," Volume  F7 <-> F8 ",COLOR_PAIR(3)); break;
    case 19: strbox(64,10,76,12,0," A N S R ",COLOR_PAIR(3)); break;
    case 20: makebox2(12, 10, 16, 12, 0,COLOR_PAIR(2)); break;
    case 23: {
               attron(COLOR_PAIR(3)); for (a=0;a<4;a++) mvaddch(16,3+a,ACS_HLINE); attroff(COLOR_PAIR(3));
               mvaddstr(16,7," F11/F12 ");
               attron(COLOR_PAIR(3)); for (a=0;a<9;a++) mvaddch(16,16+a,ACS_HLINE); attroff(COLOR_PAIR(3));  
             } break;
   }
}

void printtime(int y, int x, int time)
{
  int mins, secs;
  char buff[6];

  mins=time/60;
  secs=time%60;

  buff[0]='0'+mins/10;
  buff[1]='0'+mins%10;
  buff[2]=':';
  buff[3]='0'+secs/10;
  buff[4]='0'+secs%10;
  buff[5]=0;

  mvaddstr(y,x,buff);
}

void play_sign(void)
{
  char buff[15];
  
  strcpy(buff," Play'n  "); buff[dumbi++]='>';
  if (dumbi>7) dumbi=0;
  strpanel(50,10,61,12,0," Status ",buff, COLOR_PAIR(3), COLOR_PAIR(4));
}

void do_volume_panel(void)
{
  int tmpi;
  
  if (muted) attron(A_BLINK); attrset(A_BOLD);
  mvaddstr(5,22,"                       ");
  switch(cur_volume) {
    case 22: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
               attron(COLOR_PAIR(3));
               for(tmpi=0;tmpi<4;tmpi++) mvaddch(5,41+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(3)); 
             } break;
    case 21: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
               attron(COLOR_PAIR(3));
               for(tmpi=0;tmpi<3;tmpi++) mvaddch(5,41+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(3)); 
             } break;
    case 20: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
               attron(COLOR_PAIR(3));
               for(tmpi=0;tmpi<2;tmpi++) mvaddch(5,41+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(3)); 
             } break;
    case 19: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
               attron(COLOR_PAIR(3));
               for(tmpi=0;tmpi<1;tmpi++) mvaddch(5,41+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(3)); 
             } break;
    case 18: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;             
    case 17: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<6;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 16: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<5;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 15: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<4;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 14: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<3;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 13: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<2;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 12: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<13;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
               attron(COLOR_PAIR(7));
               for(tmpi=0;tmpi<1;tmpi++) mvaddch(5,34+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(7)); 
             } break;
    case 11: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<12;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case 10: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<11;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  9: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<10;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  8: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<9;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  7: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<8;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  6: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<7;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  5: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<6;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  4: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<5;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  3: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<4;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  2: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<3;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  1: { attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<2;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
    case  0: { attrset(A_NORMAL); attrset(A_BLINK); attron(COLOR_PAIR(4));
               for(tmpi=0;tmpi<1;tmpi++) mvaddch(5,22+tmpi,ACS_BLOCK); 
               attroff(COLOR_PAIR(4)); 
             } break;
  }
  if (muted) attroff(A_BLINK); attrset(A_NORMAL);
}


void savedashit()
{
  char filename[1000];
  char buff[1000];
  int a;
  int fd;

  strcpy(filename,DADIR);

  sprintf(buff,"%d",cur_ntracks);
  strcat(filename,buff);

  for (a=1; a<=cur_ntracks;a++) {
    sprintf(buff,"%d",cd->trk[a].length);
    strcat(filename,buff);
  }

  fd=creat(filename,0666);
  if (fd<0) return;

  sprintf(buff,"%s\n",cur_artist);
  write(fd,buff,strlen(buff));

  sprintf(buff,"%s\n",cur_cdname);
  write(fd,buff,strlen(buff));

  for (a=1; a<=cur_ntracks; a++) {
    sprintf(buff,"%s\n",cd->trk[a].songname);
    write(fd,buff,strlen(buff));
  }

  close(fd); 
}

void load()
{
  char filename[1000], buff[1000];
  int a;
  FILE *fd;
  
  strcpy(filename,DADIR);

  sprintf(buff,"%d",cur_ntracks);
  strcat(filename,buff);

  for (a=1; a<=cur_ntracks; a++) {
    sprintf(buff,"%d",cd->trk[a].length);
    strcat(filename,buff);
  }

  fd=fopen(filename,"r");
  if (fd==NULL) {
    strcpy(cd->artist,"");
    strcpy(cd->cdname,"");
  
    for (a=1; a<=cur_ntracks; a++)
    {
      sprintf(buff,"",a);
      if (!cd->trk[a].songname)
        cd->trk[a].songname=malloc(1000);
      strcpy(cd->trk[a].songname,buff);
    }  
    return;
  }
  fgets(cd->artist,320,fd); if (cd->artist[strlen(cd->artist)-1]=='\n') cd->artist[strlen(cd->artist)-1]=0;
  fgets(cd->cdname,320,fd); if (cd->cdname[strlen(cd->cdname)-1]=='\n') cd->cdname[strlen(cd->cdname)-1]=0;
  for (a=1; a<=cur_ntracks; a++) {
    fgets(buff,1000,fd);
    if (buff[strlen(buff)-1]=='\n') buff[strlen(buff)-1]=0;
    if (!cd->trk[a].songname)
      cd->trk[a].songname=malloc(1000);
    strcpy(cd->trk[a].songname,buff);
  }
  fclose(fd);  
}

void print_cmt_insignia()
{
  mvaddstr(LINES-2,1,"(c)     1996");
  attrset(A_BOLD);
  attron(COLOR_PAIR(3)); mvaddch(LINES-2,5,'C'); attroff(COLOR_PAIR(3));
  attron(COLOR_PAIR(2)); mvaddch(LINES-2,6,'M'); attroff(COLOR_PAIR(2));
  attron(COLOR_PAIR(7)); mvaddch(LINES-2,7,'t'); attroff(COLOR_PAIR(7));
  attrset(A_NORMAL);
}

         